#ifndef BONE_INC
#define BONE_INC

#include <stdio.h>

//
// Stuff for a 3d engine.
// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).
// aka hackCraft
//

#include "math3d.h"


class cBone {
  public: 
  char               *mName;
  cMatrix             mLimb;
  cMatrix             mMatrix;

  cVector             mUBase;  // up joint position in the unanimated Body
  cVector             mLBase;
  cVector             mUJoint; // up joint int the animated
  cVector             mLJoint;
  cVector             mLength;
  cVector             mCenter;
  cVector             mAnim;
  cBone              *mChildren;
  cBone              *mNext;
  SCALAR              mTimer;
  public:
                      cBone();
  void                Animate(SCALAR delta, INTEG n, cVector *keyFrames);
  void                BaseToWorld(cMatrix super, cVector length);
  void                ToWorld(cMatrix super, cVector length);
  void                ToWorld(cMatrix super, cMatrix rsuper, cVector length);
  void                Draw(cMatrix camera);
};


class cAniBone {
  public:
  INTEG               mBone;
  INTEG               mNKFrames;
  cVector            *mKFrames;
  public:
};


class cAniBody { // *.ame
  public:
  INTEG               mNAnimations;
  cAniBone           *mAnimations;
  public:
};


class cAnime {
  public:
  INTEG               mNAnimations;
  cAniBody            mAnimations;
  public:
};


class cBody { // *.bdy
  public:
  INTEG               mNBones;
  cBone              *mBones[40];
  cAnime             *mAnimations;
  public:
                      cBody();
  int                 FindBone(char *name);
  cBone              *LoadSub(FILE *f);
  void                Load(FILE *f);
  void                SaveSub(FILE *f, cBone *bone);
  void                Save(FILE *f);
  void                Scale(SCALAR f);
  INTEG               Select(cVector pos);
  void                Drag(cVector pos);
};


#endif

