#include "math3d.h"

#ifndef __win32
#include <GL/glut.h>
#else
#include <GL\glut.h>
#endif


#include "partic3d.h"


//
// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).
//



void cParticle::Draw(cMatrix camera, cVector facing, SCALAR size)
{
  cMatrix cm;
  cm.RotXYZ(facing.mV[X], facing.mV[Y], facing.mV[Z]);
  cm.MovRel(mPosition.mV[X], mPosition.mV[Y], mPosition.mV[Z]);
  cm.Mul(camera);
  glLoadMatrixf(cm.mM);
  SCALAR a = -size / 2;
  SCALAR b = +size / 2;
  glBegin(GL_QUADS);
    glTexCoord2f(0.0, 0.0);
    glVertex3f(a, a, 0.0);
    glTexCoord2f(1.0, 0.0);
    glVertex3f(b, a, 0.0);
    glTexCoord2f(1.0, 1.0);
    glVertex3f(b, b, 0.0);
    glTexCoord2f(0.0, 1);
    glVertex3f(a, b, 0.0);
  glEnd();
}

