#ifndef CONTROL_INC
#define CONTROL_INC

//
// User Control and AI.
// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).
// aka hackCraft
//


#include "objects.h"



class cControl {
  public:
  cObject           *mDevice;  // what we control

  cVector            mChasis;    // movement wishes
  cVector            mTower;
  SCALAR             mThrottle;
  
  INTEG                mWeapon; // current selected weapon

  public:
                     cControl();
  virtual void       Process();
  void               Transfer();
};


class cAI : public cControl {
  public:
  enum               { WAIT, TARGET, ATTACK, FOLLOW, FLEE, ROUTE, PATROL };
  public:
  cProjectile       *mShot;
  cVector            mSelf;
  cVector            mDest;
  INTEG                mNav;
  INTEG                mStatePointer;
  INTEG                mStateStack[64];
  SCALAR             mDisturb;
  SCALAR             mThreshold;
  cObject           *mObjectStack[64];
  public:
                     cAI();
  void               ClearState();
  void               OverideState(INTEG state, cObject *object);
  void               NewState(INTEG state, cObject *object);
  void               OldState();
  void               Process();
  void               WaitEnemy();
  void               TargetEnemy();
  void               AttackEnemy();
  void               FollowLeader();
  void               FleeEnemy();
  void               RouteNav();
  void               PatrolArea();
};


#endif

